import threading
import time

from resources.lib.api.api import API
from resources.lib.api.trakt_api import trakt, TraktAPI
from resources.lib.const import SERVICE, TRAKT, HTTP_METHOD, MEDIA_TYPE, TRAKT_LIST
from resources.lib.kodilogging import service_logger
from resources.lib.services import Service
from resources.lib.storage.sqlite import DB
from resources.lib.utils.kodiutils import parse_date, dict_of_lists_has_value
from resources.lib.utils.url import Url


class TraktService(Service):
    SERVICE_NAME = SERVICE.TRAKT_SERVICE

    def __init__(self, api):
        super(TraktService, self).__init__()
        self.last_activities = None

    def sync(self):
        if trakt.is_authenticated():
            desynced = []
            if self.last_activities:
                desynced = trakt.is_desynced(self.last_activities)
            if not self.last_activities or len(desynced) > 0:
                trakt.sync_lists_items(desynced, not self.last_activities)
                self.last_activities = trakt.last_activities()
            trakt.sync_local_kodi_files()

        t = threading.Timer(TRAKT.SYNC_INTERVAL, self.sync)
        t.daemon = True
        t.start()
